<?php

/**
 * This is the model base class for the table "settings".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "SettingsModel".
 *
 * Columns in table "settings" available as properties of the model,
 * and there are no model relations.
 *
 * @property string $key_code
 * @property string $value_code
 * @property integer $type
 * @property string $label
 * @property integer $ordering
 * @property string $created_time
 * @property string $updated_time
 *
 */
abstract class BaseSettingsModel extends GxActiveRecord {

	public static function model($className=__CLASS__) {
		return parent::model($className);
	}

	public function tableName() {
		return 'settings';
	}

	public static function label($n = 1) {
		return Yii::t('app', 'SettingsModel|SettingsModels', $n);
	}

	public static function representingColumn() {
		return 'label';
	}

	public function rules() {
		return array(
			array('key_code, label', 'required'),
			array('type, ordering', 'numerical', 'integerOnly'=>true),
			array('key_code', 'length', 'max'=>100),
			array('label', 'length', 'max'=>255),
			array('value_code, created_time, updated_time', 'safe'),
			array('value_code, type, ordering, created_time, updated_time', 'default', 'setOnEmpty' => true, 'value' => null),
			array('key_code, value_code, type, label, ordering, created_time, updated_time', 'safe', 'on'=>'search'),
		);
	}

	public function relations() {
		return array(
		);
	}

	public function pivotModels() {
		return array(
		);
	}

	public function attributeLabels() {
		return array(
			'key_code' => Yii::t('app', 'Key Code'),
			'value_code' => Yii::t('app', 'Value Code'),
			'type' => Yii::t('app', 'Type'),
			'label' => Yii::t('app', 'Label'),
			'ordering' => Yii::t('app', 'Ordering'),
			'created_time' => Yii::t('app', 'Created Time'),
			'updated_time' => Yii::t('app', 'Updated Time'),
		);
	}

	public function search() {
		$criteria = new CDbCriteria;

		$criteria->compare('key_code', $this->key_code, true);
		$criteria->compare('value_code', $this->value_code, true);
		$criteria->compare('type', $this->type);
		$criteria->compare('label', $this->label, true);
		$criteria->compare('ordering', $this->ordering);
		$criteria->compare('created_time', $this->created_time, true);
		$criteria->compare('updated_time', $this->updated_time, true);

		return new CActiveDataProvider($this, array(
			'criteria' => $criteria,
		));
	}
}